<template lang="pug">
BaseCard.x-card.b-focus-highlight(:class='{ selected: isSelected, "border-secondary": isFocused }' tabIndex='-1'
    @focusin.native='isFocused = true'
    @focusout.native='isFocused = false')
  li.p-0(key='info' v-if='showInfo')
    InfoAlert
      slot(name='info' v-bind='{ ...$data, showKeyHints }')
  li.p-0.flex-grow-1(key='body')
    slot(name='default' v-bind='{ ...$data, showKeyHints }')
    .x-overlays.m-0.p-0(key='overlays')
      .x-left-side-bar.d-flex.flex-column.align-items-end
        slot(name='left-side-bar' v-bind='{ ...$data, showKeyHints }')
      .x-right-side-bar.d-flex.flex-column.align-items-end
        slot(name='right-side-bar' v-bind='{ ...$data, showKeyHints }')
        button.x-select-btn.btn.btn-sm.btn-secondary.m-1(type='button' @click='toggleSelected')
          template(v-if='isSelected')
            kbd.mr-2(v-if='showKeyHints && isFocused') Esc
            i.fa.fa-compress-alt
          template(v-else)
            kbd.mr-2(v-if='showKeyHints && isFocused') Ctrl-Enter
            i.fa.fa-expand-alt
        button.x-info-btn.btn.btn-sm.btn-info.m-1(v-if='hasSlot("info")' title='info' @click='showInfo = !showInfo')
          kbd.mr-2(v-if="showKeyHints && isFocused") Ctrl+H
          | #[i.fa.fa-question-circle]
      .x-footer-bar
        slot(name='footer-bar' v-bind='{ ...$data, showKeyHints }')
  slot(name='card-footer' v-bind='{ ...$data, showKeyHints }')
</template>
<script src='./Card.vue.js' />
<style lang='scss'>
.x-card {
  transition: width 250ms, height 250ms;
  &.selected {
    box-shadow: 0 1rem 3rem rgba(0, 0, 0, 0.175) !important;
    position: fixed !important;
    margin: auto !important;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    z-index: 1050;
    max-height: 95vh !important;
    max-width: 95vw !important;
    width: 95vw !important;
  }
  > ul {
    overflow-y: auto;
    overflow-x: hidden;
    max-height: 100%;
    height: 100%;
    position: relative;
  }

  &:hover {
    .x-left-side-bar, .x-right-side-bar, .x-footer-bar {
      opacity: 1;
    }
  }

  .x-right-side-bar {
    position: absolute;
    left: 5px;
    right: auto;
    top: 5px;

    opacity: 0.30;
  }

  .x-right-side-bar {
    position: absolute;
    left: auto;
    right: 5px;
    top: 5px;

    opacity: 0.30;
  }

  .x-footer-bar {
    position: absolute;
    bottom: 5px;
    left: 5px;
    right: 5px;

    opacity: 0.30;
  }
}


</style>
